VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   675
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   4980
   LinkTopic       =   "Form1"
   ScaleHeight     =   45
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   332
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Parse JSON String"
      Height          =   555
      Left            =   2520
      TabIndex        =   1
      Top             =   60
      Width           =   2415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Create JSON String"
      Height          =   555
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2415
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2022

Option Explicit

Private m_JsonStr As String

Private Sub Command1_Click()
    
    Dim JsonObject As New clsJsonObject
    Dim JsonObject2 As New clsJsonObject
    Dim JsonArray As New clsJsonArray
    Dim JsonValue As New clsJsonValue
    
    Call JsonObject.SetNamedValue("Boolean", JsonValue.CreateBooleanValue(True))
    Call JsonObject.SetNamedValue("String", JsonValue.CreateStringValue("String"))
    Call JsonObject.SetNamedValue("Null", JsonValue.CreateNullValue)
    Call JsonObject.SetNamedValue("Number", JsonValue.CreateNumberValue(5.12))
    
    Call JsonArray.Append(JsonValue.CreateStringValue("ABC"))
    Call JsonArray.Append(JsonValue.CreateStringValue("DEF"))
    Call JsonArray.Append(JsonValue.CreateNumberValue(100))
    Call JsonObject.SetNamedValue("Array", JsonArray)
    
    Call JsonObject2.SetNamedValue("Name", JsonValue.CreateStringValue("YXZ"))
    Call JsonObject2.SetNamedValue("Price", JsonValue.CreateNumberValue(3.99))
    
    Call JsonObject.SetNamedValue("Object", JsonObject2)
    
    m_JsonStr = JsonObject.ToString
    
    Debug.Print m_JsonStr
  
End Sub

Private Sub Command2_Click()

    Dim lngItem As Long
    Dim Json As New clsJsonObject
    Dim JsonObject As clsJsonObject

    If Json.TryParse(m_JsonStr, JsonObject) Then

        Dim lngItems As Long
        Dim KeyValues() As KeyValuePair

        lngItems = JsonObject.GetSize

        If lngItems > 0 Then
        
            KeyValues = JsonObject.GetKeyValuePair
            For lngItem = 0 To lngItems - 1

                Dim strValueType As String
                Select Case KeyValues(lngItem).value.GetValueType
                Case JsonValueType.JsonValueType_Null
                    strValueType = "ValueType = Null"
                Case JsonValueType.JsonValueType_Boolean
                    strValueType = "ValueType = Boolean"
                Case JsonValueType.JsonValueType_Number
                    strValueType = "ValueType = Number"
                Case JsonValueType.JsonValueType_String
                    strValueType = "ValueType = String"
                Case JsonValueType.JsonValueType_Array
                    strValueType = "ValueType = Array"
                Case JsonValueType.JsonValueType_Object
                    strValueType = "ValueType = Object"
                End Select

                Debug.Print KeyValues(lngItem).key & ":" & KeyValues(lngItem).value.ToString & " (" & strValueType & ")"
            Next
        End If

        If JsonObject.HasKey("Object") Then

            Debug.Print JsonObject.GetNamedObject("Object").GetNamedString("Name")
            Debug.Print JsonObject.GetNamedObject("Object").GetNamedNumber("Price")

            If JsonObject.Remove("Object") Then Debug.Print JsonObject.ToString
        End If

        If JsonObject.HasKey("Array") Then
            Dim JsonArray As clsJsonArray
            Set JsonArray = JsonObject.GetNamedArray("Array")

            Dim JsonValues() As clsJsonValue
            
            lngItems = JsonArray.GetSize

            If lngItems > 0 Then
                JsonValues = JsonArray.GetArrayValues
                For lngItem = 0 To lngItems - 1
                    Debug.Print JsonValues(lngItem).Stringify
                Next
            End If

            For lngItem = 0 To JsonArray.GetSize - 1

                Dim JsonArrayValue As clsJsonValue
                Set JsonArrayValue = JsonArray.GetAt(lngItem)

                Debug.Print JsonArrayValue.Stringify

                Set JsonArrayValue = Nothing
            Next

            Dim JsonValue As New clsJsonValue
            If JsonObject.GetNamedArray("Array").Append(JsonValue.CreateStringValue("GHI")) Then Debug.Print JsonObject.ToString

            Debug.Print JsonObject.GetNamedArray("Array").GetAt(0).GetString
            Debug.Print JsonObject.GetNamedArray("Array").GetAt(0).ToString
            Debug.Print JsonObject.GetNamedArray("Array").GetAt(0).Stringify
            If JsonObject.GetNamedArray("Array").RemoveAt(0) Then Debug.Print JsonObject.ToString
            If JsonObject.GetNamedArray("Array").InsertAt(0, JsonValue.CreateStringValue("JKL")) Then Debug.Print JsonObject.ToString
            If JsonObject.GetNamedArray("Array").RemoveAtEnd Then Debug.Print JsonObject.ToString

        End If


        Set JsonValue = JsonValue.CreateStringValue("NewString")
        If JsonObject.Insert("String", JsonValue) Then Debug.Print JsonObject.ToString

        Set JsonValue = JsonValue.CreateStringValue("WhatEver")
        If JsonObject.Insert("Yehaaaa", JsonValue) Then Debug.Print JsonObject.ToString

    End If

End Sub
